//
//	$B%5!<%P$O%$%s%G%/%7%s%0$@$19T$J$$!"<B:]$N%U%!%$%kA`:n$O(B
//	$B9T$J$o$J$$$3$H$K$9$k!#(B
//
//	$Date: 2000/03/28 11:58:46 $
//	$Revision: 1.8 $
//
#include <stdio.h>
#include <sys/types.h>

#include "config.h"	// $B%G%#%l%/%H%j$J$I$N@_Dj(B
#include "pimserver.h"
#include "server.h"	// $B%5!<%P%i%$%V%i%jMQ(B
#include "readdata.h"	// PIM$B%G!<%?FI=P$7%i%$%V%i%j(B
#include "contents.h"	// $B%m!<%^;zJQ49(B/$B%?%$%H%k<hF@%i%$%V%i%j(B

PimEntry entries[PIMMAXENTRIES];
int nentries = 0;

//
//	ID$B$O(B14$B7e$N?t;z(B($BG/(B/$B7n(B/$BF|(B/$B;~(B/$BJ,(B/$BIC(B)$B$G!"$=$l$KBP1~$9$k%U%!%$%kL>$O(B
//	"PIMDIR/$BG/(B/$B7n(B/$BF|(B/ID.pim" $B$H$9$k!#(B
//

char *
id2filename(char *id) // ID ==> $B%U%!%$%kL>(B
{
	static char buf[100];
	sprintf(buf,"%s/%.4s/%.2s/%.2s/%s.pim",PIMDIR,id,id+4,id+6,id);
	return buf;
}

char *
filename2id(char *filename) // $B%U%!%$%kL>(B ==> ID
{
	static char buf[15];
	sprintf(buf,"%.14s",filename+strlen(filename)-14-4);
	return buf;
}

void
deleteid(char *id) // $B;XDj$5$l$?(BID$B$N%(%s%H%j$r%j%9%H$+$i>C5n(B
{
	int i;
	for(i=0;i<nentries;i++){
		if(strcmp(id,entries[i].ID)==0) break;
	}
	if(i >= nentries) return;
	if(entries[i].ID) free(entries[i].ID);
	if(entries[i].title) free(entries[i].title);
	if(entries[i].roma) free(entries[i].roma);
	for(;i<nentries-1;i++){
		entries[i] = entries[i+1];
	}
	nentries--;
}

void
addid(char *id)
{
	int i,j;
	char *filename = id2filename(id);
	for(i=0;i<nentries;i++){
		if(strcmp(id,entries[i].ID) > 0) break;
	}
	for(j=nentries;j>i;j--){
		entries[j] = entries[j-1];
	}
	entries[i].ID = strdup(id);
	entries[i].title = strdup(titlestr(filename));
	entries[i].roma = strdup(roma(filename));
	nentries++;
}

int
process(int sock)
{	
	int i,n;
	int mismatch;
	static unsigned char retbuf[50000];
	char combuf[1000];
	int retbuflen;
	unsigned char buf[1000];

	if((n = read(sock,&combuf[0],1000)) <= 0) {
		return -1;
	}
	for(i=0;(combuf[i] != '\n' && combuf[i] != '\r');i++);
	combuf[i] = '\0';

	switch(combuf[0]){
	case '0': case '1': case '2': case '3':
		mismatch = combuf[0] - '0';
		makepat(combuf+1,mismatch);
		strcpy(retbuf,"1");
		retbuflen = 1;
		for(i=n=0;i<nentries && n < PIMMAXCANDS;i++){
			if(match(entries[i].roma)){
				sprintf(buf,"[%s]\t%s\r",
					entries[i].ID,entries[i].title);
				if(retbuflen+strlen(buf) > 5000-1) break;
				strcat(retbuf,buf);
				n++;
			}
		}
		strcat(retbuf,"\n");
		if(n==0){
			strcpy(retbuf,"0\n");
		}
		break;
	case 'A': // ID$BDI2C(B
		addid(combuf+1);
		strcpy(retbuf,"1\n");
		break;
	case 'D': // ID$B:o=|(B
		deleteid(combuf+1);
		strcpy(retbuf,"1\n");
		break;
	case 'Q': // $B6/@)=*N;(B
		return -1;
	default:
		return -1;
	}
	if(write(sock, retbuf, strlen(retbuf)) < 0) {
		return -1;
	}
	return  0;
}

int
idcomp(const void *s1, const void *s2)
{
	PimEntry *p1, *p2;
	p1 = (PimEntry*)s1; p2 = (PimEntry*)s2;
	return strcmp(p2->ID,p1->ID);
}

main()
{
	readdata(PIMDIR);
	qsort(entries,nentries,sizeof(PimEntry),idcomp);
	fprintf(stderr,"Server ready\n");
	server(PIMSERVERPORT,process);
}
